REBOL [
	Title: "Uniserve: CGI module"
	Author: "SOFTINNOV / Nenad Rakocevic"
	Version: 0.9.0
	Date: 27/12/2002
]

system/options/quiet: true

install-module [
	name: 'cgi

	output: make string! 10000
	
	if native? :print [set 's-probe func [value][s-print mold :value :value]]
	
	exec-class: context [
		halt: q: quit: does [throw 'force-quit]
		input: ""
		prin: func [data][insert tail output reform data]
		print: func [data][insert tail output join reform data newline]
		probe: func [data][insert tail output mold data data]
		read-io: func [p buf len /local l][
			;s-probe "##read-io catched!"
			insert tail buf l: copy/part input len
			input: skip input l: length? l
			l
		]
	]
	
	script: path: target: msg: exe: none
	serv-name: read dns://
	save-path: system/options/path

	protect-code: func [code [block!] bytes /local ret-val err-obj type id desc][
		append code 0	; force a default return value of 0
		if error? ret-val: try [catch bind code in exe: make exec-class [input: bytes] 'self][
			err-obj: disarm ret-val
			type: err-obj/type
			id: err-obj/id
			arg1: err-obj/arg1
			arg2: err-obj/arg2
			arg3: err-obj/arg3
			desc: reduce system/error/:type/:id
			exe/prin "Content-type: text/html^/^/"
			exe/prin {
			<HTML>
				<HEAD>
					<TITLE>
						REBOL Error Catched
					</TITLE>
				</HEAD>
				<BODY><FONT face="Arial">
					<BR>
					<CENTER>
					<H2>&gt; Catched Error &lt;</H2><BR>
					<TABLE border="1">
					<TR><TD align="right"><FONT face="Arial"><B>Error Code :</B></FONT></TD>
					<TD align="left"><FONT face="Arial">}exe/prin mold err-obj/code exe/prin{</FONT></TD></TR>
					<TR><TD align="right"><FONT face="Arial"><B>Description :</B></FONT></TD>
					<TD align="left"><FONT face="Arial">}exe/prin ["<I>"type " error ! </I><BR>"desc] exe/prin{</FONT></TD></TR>
					<TR><TD align="right"><FONT face="Arial"><B>Near :</B></FONT></TD>
					<TD align="left"><FONT face="Arial">}exe/prin mold err-obj/near exe/prin{</FONT></TD></TR>
					<TR><TD align="right"><FONT face="Arial"><B>Where :</B></FONT></TD>
					<TD align="left"><FONT face="Arial">}exe/prin mold err-obj/where exe/prin{</FONT></TD></TR>
					</TABLE>
					</CENTER>
				</BODY>
			</HTML>
			}
		]
	]

	decode-all: func [data /local rule-header name value blk uri method soc][
		blk: make block! 10
		rule-header: [copy name to #":" skip copy value to #"^/" skip]
		parse/all data/2 [
			copy method to #" " skip
			copy target to #" " thru #"^/"
			any [rule-header (repend blk [name trim value])]
		]
		target: first uri: parse target "?"
		soc: system/options/cgi
	 	soc/server-software: "UniServe/HTTPd"
	    soc/server-name: serv-name
	    soc/gateway-interface: "CGI/1.1"
	    soc/server-protocol: "HTTP/1.0"
	    soc/server-port: 80
		soc/request-method: any [method ""]
	    soc/path-info: trim target
	    soc/path-translated: none
	    soc/script-name: none
	    soc/query-string: trim any [pick uri 2 ""]
	    soc/remote-host: none
	    soc/remote-addr: to-tuple data/3
	    soc/auth-type: none
	    soc/remote-user: none
	    soc/remote-ident: none
	    soc/content-type: select blk "Content-Type"
	    soc/content-length: any [all [data/4 to-string length? data/4] none]
	    soc/other-headers: blk
	]
	
	error-page:	"Content-type: text/html^/^/<html><h2>Error in CGI :</h2>"

	smart-join: func [p1 p2 /local s1 s2][
		s1: #"/" = last p1
		s2: #"/" = first p2
		any [
			all [s1 s2 remove p2]
			all [not s1 not s2 insert tail p1 #"/"]
			
		]
		join p1 p2
	]
	
	on-task-received: func [data][
		path: data/1
		decode-all data
		msg: none
		clear output
		path: smart-join path target
		system/options/script: path
		either not exists? path [msg: "File not found"][
			script: read path
			if find/only ["#!" "!#"] copy/part script 2 [script: next find script newline]
			if none? script: find script "REBOL" [msg: "REBOL header not found"]
		]
		either msg [
			return response: rejoin [error-page msg "</html>"]
		][
			change-dir first split-path path
			protect-code load script set 'input any [data/4 ""]
		]
		change-dir save-path
		response: :output
	]
]